program main
	!Different ways of communication using MPI
	use mod_communication
	use mpi
	implicit none
	integer :: ierr, rank, numProcesses, method=1, root=0, array_size, i, max_size=20000
	real, dimension(:), allocatable :: array

	call MPI_INIT(ierr)
	call MPI_COMM_RANK(MPI_COMM_WORLD, rank, ierr)
	call MPI_COMM_SIZE(MPI_COMM_WORLD, numProcesses, ierr)
	
	if (method == 1) then
		do i=1,max_size	!increase array size until producing a deadlock
			array_size = i
			call initialize_array(array_size, array)
			call deadlock(numProcesses, rank, array)
			if (rank == root) print*,'Program finished successfully with: ', i, ' array entries', i*4, ' bytes'
			deallocate(array)
		end do
	else 
		array_size = max_size
		call initialize_array(array_size, array)
		if (method == 2) then
			call no_deadlock(numProcesses, rank, array)
		else if (method == 3) then
			call non_blocking_communication(numProcesses, rank, array)
		else if (method == 4) then
			call sendrecv(numProcesses, rank, array)
		end if
		deallocate(array)
		if (rank == root) print*,'Program finished successfully. '
	end if

	call MPI_FINALIZE(ierr)

end program main
